class AspCompiler
  require 'asp/subsmatch'

  AspTag = "<%% %%> <%= <%# <% %>".split
  private
  def is_asp_tag?(s)
    AspTag.member?(s)
  end

  # ---- Tue Jul 29 00:47:29 CEST 2003 
  # SplitRegexp = /(<%%)|(%%>)|(<%=)|(<%#)|(<%)|(%>)|(\n)/
  SplitRegexp = /(<%%[\t ]*)|([\t ]*%%>)|(<%=[\t ]*)|(<%#[\t ]*)|(<%[\t ]*)|([\t ]*%>)|(\n)/
  StripRegexp = /(<%%[\t ]*)|([\t ]*%%>)|(<%=[\t ]*)|(<%#[\t ]*)|(<%[\t ]*)|([\t ]*%>)/
  # ---- 

  public
  def pre_compile(s, trim_mode)
    re = SplitRegexp
    if trim_mode.nil? || trim_mode == 0
      list = s.split(re)
    else
      list = []
      s.each do |line|
        line = line.chomp.split(re)
        line.shift if line[0]==''
        list += line
        unless ((trim_mode == 1 && line[-1] == '%>') ||
    	        (trim_mode == 2 && (is_asp_tag?(line[0])) && 
    	        line[-1] == '%>'))
          list.push("\n") 
        end
      end
    end
    list
  end

  def compile(s)
    list = pre_compile(s, @trim_mode)

    list = list.map { |x|
      if /^\s*$/.match( x ) or x == ""
        nil
      else
        x
      end
    }.compact

    s = submatch( list )
    ## DEBUG ;) ## print "<!--\n#{s}\n-->\n"

    list = pre_compile(s, @trim_mode)

    cmd = []
    cmd.concat(@pre_cmd)

    stag = nil
	# ---- Tue Jul 29 01:52:14 CEST 2003 
	laststag = nil
	# ----
    content = []
    while (token = list.shift) 
	  token.strip! if StripRegexp.match( token ) ## ---- Tue Jul 29 00:47:12 CEST 2003 
      if token == '<%%'
        token = '<'
        list.unshift '%'
      elsif token == '%%>'
        token = '%'
        list.unshift '>'
      end
      if stag.nil?
        if ['<%', '<%=', '<%#'].include?(token)
          stag = token
		  # ---- Tue Jul 29 01:52:26 CEST 2003 
		  laststag = token
          str = content.join
          if str.size > 0
            cmd.push("#{@put_cmd} #{str.dump}")
          end
          content = []
        elsif token == "\n"
		  # ---- Tue Jul 29 01:52:36 CEST 2003
		  # content.push("\n")
		  if laststag != "<%="
            content.push("\n")
		  else
		    laststag = nil
		  end
		  # ----
		  # ---- Tue Jul 29 01:53:00 CEST 2003 
		  # cmd.push("#{@put_cmd} #{content.join.dump}")
          if /<%=/ =~ list[1]
            cmd.push("#{@put_cmd} #{content.join.chomp.dump}") if content.join.chomp.dump != '""'
		  else
            cmd.push("#{@put_cmd} #{content.join.dump}") if content.join.dump != '""'
		  end
		  # ----
          cmd.push(:cr)
          content = []
        else
          content.push(token)
        end
      else
        if token == '%>'
          case stag
          when '<%'
            str = content.join
            if str[-1] == ?\n
              str.chop!
              cmd.push(str)
              cmd.push(:cr)
            else
              cmd.push(str)
            end
          when '<%='
		    # ---- Tue Jul 29 01:01:15 CEST 2003 
            # cmd.push("#{@put_cmd}((#{content.join}).to_s)")
            cmd.push("#{@put_cmd}((#{content.join.chomp.gsub( /^\n/, "" )}).to_s)")
			# ----
            ## DEBUG # print "<!-- #{@put_cmd}((#{content.join.chomp.gsub( /^\n/, "" )}).to_s) -->\n"
          when '<%#'
            # cmd.push("# #{content.dump}")
          end
          stag = nil
          content = []
        else
          content.push(token)
        end
      end
    end
    if content.size > 0
      cmd.push("#{@put_cmd} #{content.join.dump}")
    end
    cmd.push(:cr)
    cmd.concat(@post_cmd)

    ary = []
    cmd.each do |x|
      if x == :cr
        ary.pop
        ary.push("\n")
      else
        ary.push(x)
        ary.push('; ')
      end
    end
    ary.join
  end

  def initialize
    @trim_mode = nil
    @put_cmd = 'print'
    @pre_cmd = []
    @post_cmd = []
  end
  attr :trim_mode, true
  attr :put_cmd, true
  attr :pre_cmd, true
  attr :post_cmd, true
end

